

// This C++ file was created by SanEditor

#include "Atomic/Malicious_Demands_Init/Malicious_Demands_InitSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         Malicious_Demands_InitSAN Constructor             
******************************************************************/


Malicious_Demands_InitSAN::Malicious_Demands_InitSAN(){


  DemandActivityGroup.initialize(2, "DemandActivityGroup");
  DemandActivityGroup.appendGroup((BaseGroupClass*) &DemandActivity_case1);
  DemandActivityGroup.appendGroup((BaseGroupClass*) &DemandActivity_case2);

  Activity* InitialActionList[3]={
    &DoItOnce, //0
    &DemandActivity_case1, //1
    &DemandActivity_case2  // 2
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(DemandActivityGroup), 
    (BaseGroupClass*) &(DoItOnce)
  };

  InitTokens = new Place("InitTokens" ,0);
  Done = new Place("Done" ,0);
  maxDemands = new Place("maxDemands" ,0);
  Channel_ID = new Place("Channel_ID" ,0);
  SuccessCounter = new Place("SuccessCounter" ,0);
  DemandSubmitted = new Place("DemandSubmitted" ,0);
  channel_initialised = new Place("channel_initialised" ,0);
  FailledAttacksCounter = new Place("FailledAttacksCounter" ,0);
  maliciousDemand_state temp_Demand_DetailsmaliciousDemand = {0,0,0,0};
  Demand_Details = new maliciousDemand("Demand_Details",temp_Demand_DetailsmaliciousDemand);
  ChannelAttackList_state temp_ListOfAttacksChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  ListOfAttacks = new ChannelAttackList("ListOfAttacks",temp_ListOfAttacksChannelAttackList);
  double temp_ExecRatedouble = 0;
  ExecRate = new ExtendedPlace<double>("ExecRate",temp_ExecRatedouble);
  channelAttack_state temp_InputchannelAttack = {0,{0,0,0,0}};
  Input = new channelAttack("Input",temp_InputchannelAttack);
  double temp_IsActivedouble = 0;
  IsActive = new ExtendedPlace<double>("IsActive",temp_IsActivedouble);
  BaseStateVariableClass* InitialPlaces[13]={
    InitTokens,  // 0
    Done,  // 1
    maxDemands,  // 2
    Channel_ID,  // 3
    SuccessCounter,  // 4
    DemandSubmitted,  // 5
    channel_initialised,  // 6
    FailledAttacksCounter,  // 7
    Demand_Details,  // 8
    ListOfAttacks,  // 9
    ExecRate,  // 10
    Input,  // 11
    IsActive   // 12
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Malicious_Demands_Init", 13, InitialPlaces, 
                        0, InitialROPlaces, 
                        3, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[21][2]={ 
    {1,0}, {0,0}, {8,0}, {3,0}, {2,0}, {12,0}, {10,0}, {9,0}, 
    {4,1}, {5,1}, {8,1}, {12,1}, {10,1}, {9,1}, {11,1}, {3,1}, 
    {7,2}, {8,2}, {12,2}, {10,2}, {9,2}
  };
  for(int n=0;n<21;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[5][2]={ 
    {0,0}, {1,0}, {6,0}, {1,1}, {1,2}
  };
  for(int n=0;n<5;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<3;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void Malicious_Demands_InitSAN::CustomInitialization() {

}
Malicious_Demands_InitSAN::~Malicious_Demands_InitSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void Malicious_Demands_InitSAN::assignPlacesToActivitiesInst(){
  DoItOnce.InitTokens = (Place*) LocalStateVariables[0];
  DoItOnce.Done = (Place*) LocalStateVariables[1];
  DoItOnce.channel_initialised = (Place*) LocalStateVariables[6];
  DoItOnce.Demand_Details = (maliciousDemand*) LocalStateVariables[8];
  DoItOnce.Channel_ID = (Place*) LocalStateVariables[3];
  DoItOnce.maxDemands = (Place*) LocalStateVariables[2];
  DoItOnce.IsActive = (ExtendedPlace<double>*) LocalStateVariables[12];
  DoItOnce.ExecRate = (ExtendedPlace<double>*) LocalStateVariables[10];
  DoItOnce.ListOfAttacks = (ChannelAttackList*) LocalStateVariables[9];
}
void Malicious_Demands_InitSAN::assignPlacesToActivitiesTimed(){
  DemandActivity_case1.Done = (Place*) LocalStateVariables[1];
  DemandActivity_case1.SuccessCounter = (Place*) LocalStateVariables[4];
  DemandActivity_case1.DemandSubmitted = (Place*) LocalStateVariables[5];
  DemandActivity_case1.Demand_Details = (maliciousDemand*) LocalStateVariables[8];
  DemandActivity_case1.IsActive = (ExtendedPlace<double>*) LocalStateVariables[12];
  DemandActivity_case1.ExecRate = (ExtendedPlace<double>*) LocalStateVariables[10];
  DemandActivity_case1.ListOfAttacks = (ChannelAttackList*) LocalStateVariables[9];
  DemandActivity_case1.Input = (channelAttack*) LocalStateVariables[11];
  DemandActivity_case1.Channel_ID = (Place*) LocalStateVariables[3];
  DemandActivity_case2.Done = (Place*) LocalStateVariables[1];
  DemandActivity_case2.FailledAttacksCounter = (Place*) LocalStateVariables[7];
  DemandActivity_case2.Demand_Details = (maliciousDemand*) LocalStateVariables[8];
  DemandActivity_case2.IsActive = (ExtendedPlace<double>*) LocalStateVariables[12];
  DemandActivity_case2.ExecRate = (ExtendedPlace<double>*) LocalStateVariables[10];
  DemandActivity_case2.ListOfAttacks = (ChannelAttackList*) LocalStateVariables[9];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================DoItOnceActivity========================*/


Malicious_Demands_InitSAN::DoItOnceActivity::DoItOnceActivity(){
  ActivityInitialize("DoItOnce",1,Instantaneous , RaceEnabled, 8,3, false);
}

void Malicious_Demands_InitSAN::DoItOnceActivity::LinkVariables(){
  InitTokens->Register(&InitTokens_Mobius_Mark);
  Done->Register(&Done_Mobius_Mark);
  channel_initialised->Register(&channel_initialised_Mobius_Mark);

  Channel_ID->Register(&Channel_ID_Mobius_Mark);
  maxDemands->Register(&maxDemands_Mobius_Mark);



}

bool Malicious_Demands_InitSAN::DoItOnceActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((InitTokens->Mark() > 0) && (Done->Mark() == 0) && (channel_initialised->Mark() > 0)));
  return NewEnabled;
}

double Malicious_Demands_InitSAN::DoItOnceActivity::Weight(){ 
  return 1;
}

bool Malicious_Demands_InitSAN::DoItOnceActivity::ReactivationPredicate(){ 
  return false;
}

bool Malicious_Demands_InitSAN::DoItOnceActivity::ReactivationFunction(){ 
  return false;
}

double Malicious_Demands_InitSAN::DoItOnceActivity::SampleDistribution(){
  return 0;
}

double* Malicious_Demands_InitSAN::DoItOnceActivity::ReturnDistributionParameters(){
    return NULL;
}

int Malicious_Demands_InitSAN::DoItOnceActivity::Rank(){
  return 1;
}

BaseActionClass* Malicious_Demands_InitSAN::DoItOnceActivity::Fire(){
  int i, counter;
if(InitTokens->Mark() > demand_types_max)
  InitTokens->Mark() = demand_types_max;	// Fixing misconfiguring InitTokens 
Demand_Details->ID->Mark() = 0;
for (i=0;i<10;i++)
  {
    Demand_Details->FR_set->Index(0)->Mark() = 0;
  };
counter = demand_types_max - InitTokens->Mark();
cout << "\n\nOnceGate: counter: " << counter << "Channel ID: " << Channel_ID->Mark() << " InitTokens: " << InitTokens->Mark();
i = Channel_ID->Mark();
if(counter < maxDemands->Mark())
  {
    IsActive->Mark() = (double)(1.0);		// Activate the demand.
    cout << "Demand " << counter << " activated";
 }
else
 {
   IsActive->Mark() = (double)(0.0);		// Created, but not active.
 }
// Demand_Details->ID->Mark() = counter+1;		// Check if the "+1" is indeed needed
ListOfAttacks->AttacksApplied->Index(counter)->successProb->Mark() = IsActive->Mark(); 
InitTokens->Mark()--;

// Now copy the data from ListOfAttack to Demand structure. 
    Demand_Details->ID->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->ID->Mark() + 1;		// Check if the "+1" is indeed needed
    for(i=0;i<10;i++)
      {
	if(ListOfAttacks->AttacksApplied->Index(counter)->FR_set->Index(i)->Mark() == 0)
	 break;	// All copying is done!
	else
	  {
	    Demand_Details->FR_set->Index(i)->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->FR_set->Index(i)->Mark();
	  }
      };
    Demand_Details->successProb->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->successProb->Mark();
switch(counter)
  {
    case 0:
      // Now populate the FR_set(0) of Demand_Details
      switch(Channel_ID->Mark())
	{
	  case 0:
	   // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_0;
	   break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_0;
	   break;
	};
    break;
    case 1:
      // Now populate the FR_set(0) of Demand_Details
      switch(Channel_ID->Mark())
	{
	  case 0:
	    // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_1;
	   break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_1;
	   break;
	};
       break;
    case 2:
      // Now populate the FR_set(0) of Demand_Details
      switch(Channel_ID->Mark())
	{
	  case 0:
	   // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_2;
	  break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_2;
	  break;
	};
     break;
    case 3:
      // Now populate the FR_set(0) of Demand_Details
      switch(Channel_ID->Mark())
	{
	  case 0:
	   // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_3;
	  break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_3;
	   break;
	};
     break;
    case 4:
      // Now populate the FR_set(0) of Demand_Details
      switch(Channel_ID->Mark())
	{
	  case 0:
	   // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_4;
	  break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_4;
	  break;
	};
     break;
    default:
      // Now populate the remaining members of FR_set array in Demand_Details
      // Currently the same demands. Will change these to random allocation
      switch(Channel_ID->Mark())
	{
	  case 0:
	   // This is the initialisation of the first channel. 
	   ExecRate->Mark() = demand_rate_0_default;
	   break;
	  default:
	    // This is for the second channel and any other channel.
	   ExecRate->Mark() = demand_rate_1_default;
	   break;
	};
     break;
  };
ListOfAttacks->AttacksApplied->Index(counter)->AttackRate->Mark() = ExecRate->Mark();
Demand_Details->AttackRate->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->AttackRate->Mark();
  (*(Done_Mobius_Mark))++;
  return this;
}

/*======================DemandActivityActivity_case1========================*/

Malicious_Demands_InitSAN::DemandActivityActivity_case1::DemandActivityActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("DemandActivity_case1",0,Exponential, RaceEnabled, 8,1, false);
}

Malicious_Demands_InitSAN::DemandActivityActivity_case1::~DemandActivityActivity_case1(){
  delete[] TheDistributionParameters;
}

void Malicious_Demands_InitSAN::DemandActivityActivity_case1::LinkVariables(){
  Done->Register(&Done_Mobius_Mark);
  SuccessCounter->Register(&SuccessCounter_Mobius_Mark);
  DemandSubmitted->Register(&DemandSubmitted_Mobius_Mark);





  Channel_ID->Register(&Channel_ID_Mobius_Mark);
}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((// ((Done->Mark() > 0) && (FireCounter->Mark() == 0))
(Done->Mark() > 0)));
  return NewEnabled;
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case1::Rate(){
  return(ExecRate->Mark());
  return 1.0;  // default rate if none is specified
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case1::Weight(){ 
  return(IsActive->Mark());
}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case1::ReactivationFunction(){ 
  return false;
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential((ExecRate->Mark()));
}

double* Malicious_Demands_InitSAN::DemandActivityActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Malicious_Demands_InitSAN::DemandActivityActivity_case1::Rank(){
  return 1;
}

BaseActionClass* Malicious_Demands_InitSAN::DemandActivityActivity_case1::Fire(){
  int counter;
counter = Demand_Details->ID->Mark();
// Now to retrive from ListOfAttacks:
//   - attack success probability 
//   - attack rate
// and update IsActive and ExecRate, respectively, in this model.
Demand_Details->successProb->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->successProb->Mark();
Demand_Details->AttackRate->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->AttackRate->Mark();
IsActive->Mark() = Demand_Details->successProb->Mark();
ExecRate->Mark() = Demand_Details->AttackRate->Mark();
  int i;
Input->ChanID->Mark() = Channel_ID->Mark();
Input->demandDescription->ID->Mark() = Demand_Details->ID->Mark();
for(i=0;i<10;i++)
  {
    if(Demand_Details->FR_set->Index(i)->Mark() == 0)
      break;	// All copying is done!
    else
      {
    	Input->demandDescription->FR_set->Index(i)->Mark() = Demand_Details->FR_set->Index(i)->Mark();
      }
  };
  (*(SuccessCounter_Mobius_Mark))++;
  (*(DemandSubmitted_Mobius_Mark))++;
  return this;
}

/*======================DemandActivityActivity_case2========================*/

Malicious_Demands_InitSAN::DemandActivityActivity_case2::DemandActivityActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("DemandActivity_case2",0,Exponential, RaceEnabled, 5,1, false);
}

Malicious_Demands_InitSAN::DemandActivityActivity_case2::~DemandActivityActivity_case2(){
  delete[] TheDistributionParameters;
}

void Malicious_Demands_InitSAN::DemandActivityActivity_case2::LinkVariables(){
  Done->Register(&Done_Mobius_Mark);
  FailledAttacksCounter->Register(&FailledAttacksCounter_Mobius_Mark);




}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((// ((Done->Mark() > 0) && (FireCounter->Mark() == 0))
(Done->Mark() > 0)));
  return NewEnabled;
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case2::Rate(){
  return(ExecRate->Mark());
  return 1.0;  // default rate if none is specified
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case2::Weight(){ 
  return(1.0 - IsActive->Mark());
}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool Malicious_Demands_InitSAN::DemandActivityActivity_case2::ReactivationFunction(){ 
  return false;
}

double Malicious_Demands_InitSAN::DemandActivityActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential((ExecRate->Mark()));
}

double* Malicious_Demands_InitSAN::DemandActivityActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Malicious_Demands_InitSAN::DemandActivityActivity_case2::Rank(){
  return 1;
}

BaseActionClass* Malicious_Demands_InitSAN::DemandActivityActivity_case2::Fire(){
  int counter;
counter = Demand_Details->ID->Mark();
// Now to retrive from ListOfAttacks:
//   - attack success probability 
//   - attack rate
// and update IsActive and ExecRate, respectively, in this model.
Demand_Details->successProb->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->successProb->Mark();
Demand_Details->AttackRate->Mark() = ListOfAttacks->AttacksApplied->Index(counter)->AttackRate->Mark();
IsActive->Mark() = Demand_Details->successProb->Mark();
ExecRate->Mark() = Demand_Details->AttackRate->Mark();
  (*(FailledAttacksCounter_Mobius_Mark))++;
  return this;
}

