
#include "Study/study_2/study_2SetStudy.h"

//******************************************************
//Global Variables
//******************************************************
double FR_increment;
double FR_init_pfd;
double FR_other_pfd;
double attackRateIncrement;
double attack_success_prob_reduction;
double ch1_init_pfd;
double ch2_init_pfd;
short cleansing_enabled;
double cleansing_half_interval;
double common_pfd;
double compromise_detection_prob;
double delay_sync_attack;
double demand_default_rate;
double demand_rate_0_0;
double demand_rate_0_1;
double demand_rate_0_2;
double demand_rate_0_3;
double demand_rate_0_4;
double demand_rate_0_default;
double demand_rate_1_0;
double demand_rate_1_1;
double demand_rate_1_2;
double demand_rate_1_3;
double demand_rate_1_4;
double demand_rate_1_default;
short demand_types_ch1;
short demand_types_ch2;
short demand_types_max;
double evolutionInterval;
short evolution_enabled;
short isAttackListTheSame;
short isPatchingDelayed;
short malicious_demand_max_FRs;
double normal_demands_intervals;
double patchingInterval;
double patching_channel_pfd_reduction;
double patching_common_pfd_reduction;
short patching_enabled;
int patching_model;
short time_sync_enabled;
double upgrade_duration;

//********************************************************
//study_2SetStudy Constructor
//********************************************************
study_2SetStudy::study_2SetStudy() {

  // define arrays of global variable names and types
  NumGVs = 41;
  NumExps = 15;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];
  GVNames[0]=strdup("FR_increment");
  GVTypes[0]=strdup("double");
  GVNames[1]=strdup("FR_init_pfd");
  GVTypes[1]=strdup("double");
  GVNames[2]=strdup("FR_other_pfd");
  GVTypes[2]=strdup("double");
  GVNames[3]=strdup("attackRateIncrement");
  GVTypes[3]=strdup("double");
  GVNames[4]=strdup("attack_success_prob_reduction");
  GVTypes[4]=strdup("double");
  GVNames[5]=strdup("ch1_init_pfd");
  GVTypes[5]=strdup("double");
  GVNames[6]=strdup("ch2_init_pfd");
  GVTypes[6]=strdup("double");
  GVNames[7]=strdup("cleansing_enabled");
  GVTypes[7]=strdup("short");
  GVNames[8]=strdup("cleansing_half_interval");
  GVTypes[8]=strdup("double");
  GVNames[9]=strdup("common_pfd");
  GVTypes[9]=strdup("double");
  GVNames[10]=strdup("compromise_detection_prob");
  GVTypes[10]=strdup("double");
  GVNames[11]=strdup("delay_sync_attack");
  GVTypes[11]=strdup("double");
  GVNames[12]=strdup("demand_default_rate");
  GVTypes[12]=strdup("double");
  GVNames[13]=strdup("demand_rate_0_0");
  GVTypes[13]=strdup("double");
  GVNames[14]=strdup("demand_rate_0_1");
  GVTypes[14]=strdup("double");
  GVNames[15]=strdup("demand_rate_0_2");
  GVTypes[15]=strdup("double");
  GVNames[16]=strdup("demand_rate_0_3");
  GVTypes[16]=strdup("double");
  GVNames[17]=strdup("demand_rate_0_4");
  GVTypes[17]=strdup("double");
  GVNames[18]=strdup("demand_rate_0_default");
  GVTypes[18]=strdup("double");
  GVNames[19]=strdup("demand_rate_1_0");
  GVTypes[19]=strdup("double");
  GVNames[20]=strdup("demand_rate_1_1");
  GVTypes[20]=strdup("double");
  GVNames[21]=strdup("demand_rate_1_2");
  GVTypes[21]=strdup("double");
  GVNames[22]=strdup("demand_rate_1_3");
  GVTypes[22]=strdup("double");
  GVNames[23]=strdup("demand_rate_1_4");
  GVTypes[23]=strdup("double");
  GVNames[24]=strdup("demand_rate_1_default");
  GVTypes[24]=strdup("double");
  GVNames[25]=strdup("demand_types_ch1");
  GVTypes[25]=strdup("short");
  GVNames[26]=strdup("demand_types_ch2");
  GVTypes[26]=strdup("short");
  GVNames[27]=strdup("demand_types_max");
  GVTypes[27]=strdup("short");
  GVNames[28]=strdup("evolutionInterval");
  GVTypes[28]=strdup("double");
  GVNames[29]=strdup("evolution_enabled");
  GVTypes[29]=strdup("short");
  GVNames[30]=strdup("isAttackListTheSame");
  GVTypes[30]=strdup("short");
  GVNames[31]=strdup("isPatchingDelayed");
  GVTypes[31]=strdup("short");
  GVNames[32]=strdup("malicious_demand_max_FRs");
  GVTypes[32]=strdup("short");
  GVNames[33]=strdup("normal_demands_intervals");
  GVTypes[33]=strdup("double");
  GVNames[34]=strdup("patchingInterval");
  GVTypes[34]=strdup("double");
  GVNames[35]=strdup("patching_channel_pfd_reduction");
  GVTypes[35]=strdup("double");
  GVNames[36]=strdup("patching_common_pfd_reduction");
  GVTypes[36]=strdup("double");
  GVNames[37]=strdup("patching_enabled");
  GVTypes[37]=strdup("short");
  GVNames[38]=strdup("patching_model");
  GVTypes[38]=strdup("int");
  GVNames[39]=strdup("time_sync_enabled");
  GVTypes[39]=strdup("short");
  GVNames[40]=strdup("upgrade_duration");
  GVTypes[40]=strdup("double");

  // create the arrays to store the values of each gv
  FR_incrementValues = new double[NumExps];
  FR_init_pfdValues = new double[NumExps];
  FR_other_pfdValues = new double[NumExps];
  attackRateIncrementValues = new double[NumExps];
  attack_success_prob_reductionValues = new double[NumExps];
  ch1_init_pfdValues = new double[NumExps];
  ch2_init_pfdValues = new double[NumExps];
  cleansing_enabledValues = new short[NumExps];
  cleansing_half_intervalValues = new double[NumExps];
  common_pfdValues = new double[NumExps];
  compromise_detection_probValues = new double[NumExps];
  delay_sync_attackValues = new double[NumExps];
  demand_default_rateValues = new double[NumExps];
  demand_rate_0_0Values = new double[NumExps];
  demand_rate_0_1Values = new double[NumExps];
  demand_rate_0_2Values = new double[NumExps];
  demand_rate_0_3Values = new double[NumExps];
  demand_rate_0_4Values = new double[NumExps];
  demand_rate_0_defaultValues = new double[NumExps];
  demand_rate_1_0Values = new double[NumExps];
  demand_rate_1_1Values = new double[NumExps];
  demand_rate_1_2Values = new double[NumExps];
  demand_rate_1_3Values = new double[NumExps];
  demand_rate_1_4Values = new double[NumExps];
  demand_rate_1_defaultValues = new double[NumExps];
  demand_types_ch1Values = new short[NumExps];
  demand_types_ch2Values = new short[NumExps];
  demand_types_maxValues = new short[NumExps];
  evolutionIntervalValues = new double[NumExps];
  evolution_enabledValues = new short[NumExps];
  isAttackListTheSameValues = new short[NumExps];
  isPatchingDelayedValues = new short[NumExps];
  malicious_demand_max_FRsValues = new short[NumExps];
  normal_demands_intervalsValues = new double[NumExps];
  patchingIntervalValues = new double[NumExps];
  patching_channel_pfd_reductionValues = new double[NumExps];
  patching_common_pfd_reductionValues = new double[NumExps];
  patching_enabledValues = new short[NumExps];
  patching_modelValues = new int[NumExps];
  time_sync_enabledValues = new short[NumExps];
  upgrade_durationValues = new double[NumExps];

  // call methods to assign values to each gv
  SetValues_FR_increment();
  SetValues_FR_init_pfd();
  SetValues_FR_other_pfd();
  SetValues_attackRateIncrement();
  SetValues_attack_success_prob_reduction();
  SetValues_ch1_init_pfd();
  SetValues_ch2_init_pfd();
  SetValues_cleansing_enabled();
  SetValues_cleansing_half_interval();
  SetValues_common_pfd();
  SetValues_compromise_detection_prob();
  SetValues_delay_sync_attack();
  SetValues_demand_default_rate();
  SetValues_demand_rate_0_0();
  SetValues_demand_rate_0_1();
  SetValues_demand_rate_0_2();
  SetValues_demand_rate_0_3();
  SetValues_demand_rate_0_4();
  SetValues_demand_rate_0_default();
  SetValues_demand_rate_1_0();
  SetValues_demand_rate_1_1();
  SetValues_demand_rate_1_2();
  SetValues_demand_rate_1_3();
  SetValues_demand_rate_1_4();
  SetValues_demand_rate_1_default();
  SetValues_demand_types_ch1();
  SetValues_demand_types_ch2();
  SetValues_demand_types_max();
  SetValues_evolutionInterval();
  SetValues_evolution_enabled();
  SetValues_isAttackListTheSame();
  SetValues_isPatchingDelayed();
  SetValues_malicious_demand_max_FRs();
  SetValues_normal_demands_intervals();
  SetValues_patchingInterval();
  SetValues_patching_channel_pfd_reduction();
  SetValues_patching_common_pfd_reduction();
  SetValues_patching_enabled();
  SetValues_patching_model();
  SetValues_time_sync_enabled();
  SetValues_upgrade_duration();
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//study_2SetStudy Destructor
//******************************************************
study_2SetStudy::~study_2SetStudy() {
  delete [] FR_incrementValues;
  delete [] FR_init_pfdValues;
  delete [] FR_other_pfdValues;
  delete [] attackRateIncrementValues;
  delete [] attack_success_prob_reductionValues;
  delete [] ch1_init_pfdValues;
  delete [] ch2_init_pfdValues;
  delete [] cleansing_enabledValues;
  delete [] cleansing_half_intervalValues;
  delete [] common_pfdValues;
  delete [] compromise_detection_probValues;
  delete [] delay_sync_attackValues;
  delete [] demand_default_rateValues;
  delete [] demand_rate_0_0Values;
  delete [] demand_rate_0_1Values;
  delete [] demand_rate_0_2Values;
  delete [] demand_rate_0_3Values;
  delete [] demand_rate_0_4Values;
  delete [] demand_rate_0_defaultValues;
  delete [] demand_rate_1_0Values;
  delete [] demand_rate_1_1Values;
  delete [] demand_rate_1_2Values;
  delete [] demand_rate_1_3Values;
  delete [] demand_rate_1_4Values;
  delete [] demand_rate_1_defaultValues;
  delete [] demand_types_ch1Values;
  delete [] demand_types_ch2Values;
  delete [] demand_types_maxValues;
  delete [] evolutionIntervalValues;
  delete [] evolution_enabledValues;
  delete [] isAttackListTheSameValues;
  delete [] isPatchingDelayedValues;
  delete [] malicious_demand_max_FRsValues;
  delete [] normal_demands_intervalsValues;
  delete [] patchingIntervalValues;
  delete [] patching_channel_pfd_reductionValues;
  delete [] patching_common_pfd_reductionValues;
  delete [] patching_enabledValues;
  delete [] patching_modelValues;
  delete [] time_sync_enabledValues;
  delete [] upgrade_durationValues;
  delete ThePVModel;
}


//******************************************************
// set values for FR_increment
//******************************************************
void study_2SetStudy::SetValues_FR_increment() {
  for (int n=0; n<NumExps; n++)
    FR_incrementValues[n] = 1.0E-4;
}


//******************************************************
// set values for FR_init_pfd
//******************************************************
void study_2SetStudy::SetValues_FR_init_pfd() {
  for (int n=0; n<NumExps; n++)
    FR_init_pfdValues[n] = 1.0E-4;
}


//******************************************************
// set values for FR_other_pfd
//******************************************************
void study_2SetStudy::SetValues_FR_other_pfd() {
  for (int n=0; n<NumExps; n++)
    FR_other_pfdValues[n] = 1.0E-5;
}


//******************************************************
// set values for attackRateIncrement
//******************************************************
void study_2SetStudy::SetValues_attackRateIncrement() {
  for (int n=0; n<NumExps; n++)
    attackRateIncrementValues[n] = 0.001;
}


//******************************************************
// set values for attack_success_prob_reduction
//******************************************************
void study_2SetStudy::SetValues_attack_success_prob_reduction() {
  for (int n=0; n<NumExps; n++)
    attack_success_prob_reductionValues[n] = 0.95;
}


//******************************************************
// set values for ch1_init_pfd
//******************************************************
void study_2SetStudy::SetValues_ch1_init_pfd() {
  for (int n=0; n<NumExps; n++)
    ch1_init_pfdValues[n] = 0.002;
}


//******************************************************
// set values for ch2_init_pfd
//******************************************************
void study_2SetStudy::SetValues_ch2_init_pfd() {
  for (int n=0; n<NumExps; n++)
    ch2_init_pfdValues[n] = 0.002;
}


//******************************************************
// set values for cleansing_enabled
//******************************************************
void study_2SetStudy::SetValues_cleansing_enabled() {
  cleansing_enabledValues[0] = 1;
  cleansing_enabledValues[1] = 1;
  cleansing_enabledValues[2] = 1;
  cleansing_enabledValues[3] = 1;
  cleansing_enabledValues[4] = 1;
  cleansing_enabledValues[5] = 0;
  cleansing_enabledValues[6] = 0;
  cleansing_enabledValues[7] = 0;
  cleansing_enabledValues[8] = 0;
  cleansing_enabledValues[9] = 0;
  cleansing_enabledValues[10] = 1;
  cleansing_enabledValues[11] = 1;
  cleansing_enabledValues[12] = 1;
  cleansing_enabledValues[13] = 1;
  cleansing_enabledValues[14] = 1;
}


//******************************************************
// set values for cleansing_half_interval
//******************************************************
void study_2SetStudy::SetValues_cleansing_half_interval() {
  for (int n=0; n<NumExps; n++)
    cleansing_half_intervalValues[n] = 1;
}


//******************************************************
// set values for common_pfd
//******************************************************
void study_2SetStudy::SetValues_common_pfd() {
  for (int n=0; n<NumExps; n++)
    common_pfdValues[n] = 1.00E-04;
}


//******************************************************
// set values for compromise_detection_prob
//******************************************************
void study_2SetStudy::SetValues_compromise_detection_prob() {
  compromise_detection_probValues[0] = 0;
  compromise_detection_probValues[1] = 0;
  compromise_detection_probValues[2] = 0;
  compromise_detection_probValues[3] = 0;
  compromise_detection_probValues[4] = 0;
  compromise_detection_probValues[5] = 0;
  compromise_detection_probValues[6] = 0.2;
  compromise_detection_probValues[7] = 0.5;
  compromise_detection_probValues[8] = 0.8;
  compromise_detection_probValues[9] = 0.0;
  compromise_detection_probValues[10] = 0.0;
  compromise_detection_probValues[11] = 0;
  compromise_detection_probValues[12] = 0;
  compromise_detection_probValues[13] = 0;
  compromise_detection_probValues[14] = 0;
}


//******************************************************
// set values for delay_sync_attack
//******************************************************
void study_2SetStudy::SetValues_delay_sync_attack() {
  for (int n=0; n<NumExps; n++)
    delay_sync_attackValues[n] = 0.05;
}


//******************************************************
// set values for demand_default_rate
//******************************************************
void study_2SetStudy::SetValues_demand_default_rate() {
  for (int n=0; n<NumExps; n++)
    demand_default_rateValues[n] = 0.01;
}


//******************************************************
// set values for demand_rate_0_0
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_0() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_0Values[n] = 0.01;
}


//******************************************************
// set values for demand_rate_0_1
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_1() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_1Values[n] = 0.02;
}


//******************************************************
// set values for demand_rate_0_2
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_2() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_2Values[n] = 0.03;
}


//******************************************************
// set values for demand_rate_0_3
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_3() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_3Values[n] = 0.04;
}


//******************************************************
// set values for demand_rate_0_4
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_4() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_4Values[n] = 0.05;
}


//******************************************************
// set values for demand_rate_0_default
//******************************************************
void study_2SetStudy::SetValues_demand_rate_0_default() {
  for (int n=0; n<NumExps; n++)
    demand_rate_0_defaultValues[n] = 0.06;
}


//******************************************************
// set values for demand_rate_1_0
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_0() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_0Values[n] = 0.011;
}


//******************************************************
// set values for demand_rate_1_1
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_1() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_1Values[n] = 0.022;
}


//******************************************************
// set values for demand_rate_1_2
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_2() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_2Values[n] = 0.033;
}


//******************************************************
// set values for demand_rate_1_3
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_3() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_3Values[n] = 0.044;
}


//******************************************************
// set values for demand_rate_1_4
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_4() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_4Values[n] = 0.055;
}


//******************************************************
// set values for demand_rate_1_default
//******************************************************
void study_2SetStudy::SetValues_demand_rate_1_default() {
  for (int n=0; n<NumExps; n++)
    demand_rate_1_defaultValues[n] = 0.066;
}


//******************************************************
// set values for demand_types_ch1
//******************************************************
void study_2SetStudy::SetValues_demand_types_ch1() {
  for (int n=0; n<NumExps; n++)
    demand_types_ch1Values[n] = 10;
}


//******************************************************
// set values for demand_types_ch2
//******************************************************
void study_2SetStudy::SetValues_demand_types_ch2() {
  for (int n=0; n<NumExps; n++)
    demand_types_ch2Values[n] = 10;
}


//******************************************************
// set values for demand_types_max
//******************************************************
void study_2SetStudy::SetValues_demand_types_max() {
  for (int n=0; n<NumExps; n++)
    demand_types_maxValues[n] = 15;
}


//******************************************************
// set values for evolutionInterval
//******************************************************
void study_2SetStudy::SetValues_evolutionInterval() {
  for (int n=0; n<NumExps; n++)
    evolutionIntervalValues[n] = 0.02;
}


//******************************************************
// set values for evolution_enabled
//******************************************************
void study_2SetStudy::SetValues_evolution_enabled() {
  for (int n=0; n<NumExps; n++)
    evolution_enabledValues[n] = 1;
}


//******************************************************
// set values for isAttackListTheSame
//******************************************************
void study_2SetStudy::SetValues_isAttackListTheSame() {
  for (int n=0; n<NumExps; n++)
    isAttackListTheSameValues[n] = 1;
}


//******************************************************
// set values for isPatchingDelayed
//******************************************************
void study_2SetStudy::SetValues_isPatchingDelayed() {
  for (int n=0; n<NumExps; n++)
    isPatchingDelayedValues[n] = 1;
}


//******************************************************
// set values for malicious_demand_max_FRs
//******************************************************
void study_2SetStudy::SetValues_malicious_demand_max_FRs() {
  for (int n=0; n<NumExps; n++)
    malicious_demand_max_FRsValues[n] = 10;
}


//******************************************************
// set values for normal_demands_intervals
//******************************************************
void study_2SetStudy::SetValues_normal_demands_intervals() {
  for (int n=0; n<NumExps; n++)
    normal_demands_intervalsValues[n] = 1.0;
}


//******************************************************
// set values for patchingInterval
//******************************************************
void study_2SetStudy::SetValues_patchingInterval() {
  for (int n=0; n<NumExps; n++)
    patchingIntervalValues[n] = 0.15;
}


//******************************************************
// set values for patching_channel_pfd_reduction
//******************************************************
void study_2SetStudy::SetValues_patching_channel_pfd_reduction() {
  for (int n=0; n<NumExps; n++)
    patching_channel_pfd_reductionValues[n] = 0.9;
}


//******************************************************
// set values for patching_common_pfd_reduction
//******************************************************
void study_2SetStudy::SetValues_patching_common_pfd_reduction() {
  for (int n=0; n<NumExps; n++)
    patching_common_pfd_reductionValues[n] = 0.95;
}


//******************************************************
// set values for patching_enabled
//******************************************************
void study_2SetStudy::SetValues_patching_enabled() {
  patching_enabledValues[0] = 0;
  patching_enabledValues[1] = 0;
  patching_enabledValues[2] = 0;
  patching_enabledValues[3] = 0;
  patching_enabledValues[4] = 0;
  patching_enabledValues[5] = 0;
  patching_enabledValues[6] = 1;
  patching_enabledValues[7] = 1;
  patching_enabledValues[8] = 1;
  patching_enabledValues[9] = 1;
  patching_enabledValues[10] = 1;
  patching_enabledValues[11] = 1;
  patching_enabledValues[12] = 1;
  patching_enabledValues[13] = 1;
  patching_enabledValues[14] = 1;
}


//******************************************************
// set values for patching_model
//******************************************************
void study_2SetStudy::SetValues_patching_model() {
  patching_modelValues[0] = 0;
  patching_modelValues[1] = 0;
  patching_modelValues[2] = 0;
  patching_modelValues[3] = 0;
  patching_modelValues[4] = 0;
  patching_modelValues[5] = 0;
  patching_modelValues[6] = 1;
  patching_modelValues[7] = 1;
  patching_modelValues[8] = 1;
  patching_modelValues[9] = 1;
  patching_modelValues[10] = 1;
  patching_modelValues[11] = 1;
  patching_modelValues[12] = 1;
  patching_modelValues[13] = 1;
  patching_modelValues[14] = 1;
}


//******************************************************
// set values for time_sync_enabled
//******************************************************
void study_2SetStudy::SetValues_time_sync_enabled() {
  for (int n=0; n<NumExps; n++)
    time_sync_enabledValues[n] = 1;
}


//******************************************************
// set values for upgrade_duration
//******************************************************
void study_2SetStudy::SetValues_upgrade_duration() {
  upgrade_durationValues[0] = 0.01;
  upgrade_durationValues[1] = 0.001;
  upgrade_durationValues[2] = 0.005;
  upgrade_durationValues[3] = 0.05;
  upgrade_durationValues[4] = 0.1;
  upgrade_durationValues[5] = 0.01;
  upgrade_durationValues[6] = 0.01;
  upgrade_durationValues[7] = 0.01;
  upgrade_durationValues[8] = 0.01;
  upgrade_durationValues[9] = 0.01;
  upgrade_durationValues[10] = 0.01;
  upgrade_durationValues[11] = 0.001;
  upgrade_durationValues[12] = 0.005;
  upgrade_durationValues[13] = 0.05;
  upgrade_durationValues[14] = 0.1;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void study_2SetStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
  cout << "FR_increment\tdouble\t" << FR_increment << endl;
  cout << "FR_init_pfd\tdouble\t" << FR_init_pfd << endl;
  cout << "FR_other_pfd\tdouble\t" << FR_other_pfd << endl;
  cout << "attackRateIncrement\tdouble\t" << attackRateIncrement << endl;
  cout << "attack_success_prob_reduction\tdouble\t" << attack_success_prob_reduction << endl;
  cout << "ch1_init_pfd\tdouble\t" << ch1_init_pfd << endl;
  cout << "ch2_init_pfd\tdouble\t" << ch2_init_pfd << endl;
  cout << "cleansing_enabled\tshort\t" << cleansing_enabled << endl;
  cout << "cleansing_half_interval\tdouble\t" << cleansing_half_interval << endl;
  cout << "common_pfd\tdouble\t" << common_pfd << endl;
  cout << "compromise_detection_prob\tdouble\t" << compromise_detection_prob << endl;
  cout << "delay_sync_attack\tdouble\t" << delay_sync_attack << endl;
  cout << "demand_default_rate\tdouble\t" << demand_default_rate << endl;
  cout << "demand_rate_0_0\tdouble\t" << demand_rate_0_0 << endl;
  cout << "demand_rate_0_1\tdouble\t" << demand_rate_0_1 << endl;
  cout << "demand_rate_0_2\tdouble\t" << demand_rate_0_2 << endl;
  cout << "demand_rate_0_3\tdouble\t" << demand_rate_0_3 << endl;
  cout << "demand_rate_0_4\tdouble\t" << demand_rate_0_4 << endl;
  cout << "demand_rate_0_default\tdouble\t" << demand_rate_0_default << endl;
  cout << "demand_rate_1_0\tdouble\t" << demand_rate_1_0 << endl;
  cout << "demand_rate_1_1\tdouble\t" << demand_rate_1_1 << endl;
  cout << "demand_rate_1_2\tdouble\t" << demand_rate_1_2 << endl;
  cout << "demand_rate_1_3\tdouble\t" << demand_rate_1_3 << endl;
  cout << "demand_rate_1_4\tdouble\t" << demand_rate_1_4 << endl;
  cout << "demand_rate_1_default\tdouble\t" << demand_rate_1_default << endl;
  cout << "demand_types_ch1\tshort\t" << demand_types_ch1 << endl;
  cout << "demand_types_ch2\tshort\t" << demand_types_ch2 << endl;
  cout << "demand_types_max\tshort\t" << demand_types_max << endl;
  cout << "evolutionInterval\tdouble\t" << evolutionInterval << endl;
  cout << "evolution_enabled\tshort\t" << evolution_enabled << endl;
  cout << "isAttackListTheSame\tshort\t" << isAttackListTheSame << endl;
  cout << "isPatchingDelayed\tshort\t" << isPatchingDelayed << endl;
  cout << "malicious_demand_max_FRs\tshort\t" << malicious_demand_max_FRs << endl;
  cout << "normal_demands_intervals\tdouble\t" << normal_demands_intervals << endl;
  cout << "patchingInterval\tdouble\t" << patchingInterval << endl;
  cout << "patching_channel_pfd_reduction\tdouble\t" << patching_channel_pfd_reduction << endl;
  cout << "patching_common_pfd_reduction\tdouble\t" << patching_common_pfd_reduction << endl;
  cout << "patching_enabled\tshort\t" << patching_enabled << endl;
  cout << "patching_model\tint\t" << patching_model << endl;
  cout << "time_sync_enabled\tshort\t" << time_sync_enabled << endl;
  cout << "upgrade_duration\tdouble\t" << upgrade_duration << endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *study_2SetStudy::GetGVValue(char *TheGVName) {
  if (strcmp("FR_increment", TheGVName) == 0)
    return &FR_increment;
  else if (strcmp("FR_init_pfd", TheGVName) == 0)
    return &FR_init_pfd;
  else if (strcmp("FR_other_pfd", TheGVName) == 0)
    return &FR_other_pfd;
  else if (strcmp("attackRateIncrement", TheGVName) == 0)
    return &attackRateIncrement;
  else if (strcmp("attack_success_prob_reduction", TheGVName) == 0)
    return &attack_success_prob_reduction;
  else if (strcmp("ch1_init_pfd", TheGVName) == 0)
    return &ch1_init_pfd;
  else if (strcmp("ch2_init_pfd", TheGVName) == 0)
    return &ch2_init_pfd;
  else if (strcmp("cleansing_enabled", TheGVName) == 0)
    return &cleansing_enabled;
  else if (strcmp("cleansing_half_interval", TheGVName) == 0)
    return &cleansing_half_interval;
  else if (strcmp("common_pfd", TheGVName) == 0)
    return &common_pfd;
  else if (strcmp("compromise_detection_prob", TheGVName) == 0)
    return &compromise_detection_prob;
  else if (strcmp("delay_sync_attack", TheGVName) == 0)
    return &delay_sync_attack;
  else if (strcmp("demand_default_rate", TheGVName) == 0)
    return &demand_default_rate;
  else if (strcmp("demand_rate_0_0", TheGVName) == 0)
    return &demand_rate_0_0;
  else if (strcmp("demand_rate_0_1", TheGVName) == 0)
    return &demand_rate_0_1;
  else if (strcmp("demand_rate_0_2", TheGVName) == 0)
    return &demand_rate_0_2;
  else if (strcmp("demand_rate_0_3", TheGVName) == 0)
    return &demand_rate_0_3;
  else if (strcmp("demand_rate_0_4", TheGVName) == 0)
    return &demand_rate_0_4;
  else if (strcmp("demand_rate_0_default", TheGVName) == 0)
    return &demand_rate_0_default;
  else if (strcmp("demand_rate_1_0", TheGVName) == 0)
    return &demand_rate_1_0;
  else if (strcmp("demand_rate_1_1", TheGVName) == 0)
    return &demand_rate_1_1;
  else if (strcmp("demand_rate_1_2", TheGVName) == 0)
    return &demand_rate_1_2;
  else if (strcmp("demand_rate_1_3", TheGVName) == 0)
    return &demand_rate_1_3;
  else if (strcmp("demand_rate_1_4", TheGVName) == 0)
    return &demand_rate_1_4;
  else if (strcmp("demand_rate_1_default", TheGVName) == 0)
    return &demand_rate_1_default;
  else if (strcmp("demand_types_ch1", TheGVName) == 0)
    return &demand_types_ch1;
  else if (strcmp("demand_types_ch2", TheGVName) == 0)
    return &demand_types_ch2;
  else if (strcmp("demand_types_max", TheGVName) == 0)
    return &demand_types_max;
  else if (strcmp("evolutionInterval", TheGVName) == 0)
    return &evolutionInterval;
  else if (strcmp("evolution_enabled", TheGVName) == 0)
    return &evolution_enabled;
  else if (strcmp("isAttackListTheSame", TheGVName) == 0)
    return &isAttackListTheSame;
  else if (strcmp("isPatchingDelayed", TheGVName) == 0)
    return &isPatchingDelayed;
  else if (strcmp("malicious_demand_max_FRs", TheGVName) == 0)
    return &malicious_demand_max_FRs;
  else if (strcmp("normal_demands_intervals", TheGVName) == 0)
    return &normal_demands_intervals;
  else if (strcmp("patchingInterval", TheGVName) == 0)
    return &patchingInterval;
  else if (strcmp("patching_channel_pfd_reduction", TheGVName) == 0)
    return &patching_channel_pfd_reduction;
  else if (strcmp("patching_common_pfd_reduction", TheGVName) == 0)
    return &patching_common_pfd_reduction;
  else if (strcmp("patching_enabled", TheGVName) == 0)
    return &patching_enabled;
  else if (strcmp("patching_model", TheGVName) == 0)
    return &patching_model;
  else if (strcmp("time_sync_enabled", TheGVName) == 0)
    return &time_sync_enabled;
  else if (strcmp("upgrade_duration", TheGVName) == 0)
    return &upgrade_duration;
  else 
    cerr<<"!! study_2SetStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void study_2SetStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  if (strcmp("FR_increment", TheGVName) == 0)
    FR_increment = *(double *)TheGVValue;
  else if (strcmp("FR_init_pfd", TheGVName) == 0)
    FR_init_pfd = *(double *)TheGVValue;
  else if (strcmp("FR_other_pfd", TheGVName) == 0)
    FR_other_pfd = *(double *)TheGVValue;
  else if (strcmp("attackRateIncrement", TheGVName) == 0)
    attackRateIncrement = *(double *)TheGVValue;
  else if (strcmp("attack_success_prob_reduction", TheGVName) == 0)
    attack_success_prob_reduction = *(double *)TheGVValue;
  else if (strcmp("ch1_init_pfd", TheGVName) == 0)
    ch1_init_pfd = *(double *)TheGVValue;
  else if (strcmp("ch2_init_pfd", TheGVName) == 0)
    ch2_init_pfd = *(double *)TheGVValue;
  else if (strcmp("cleansing_enabled", TheGVName) == 0)
    cleansing_enabled = *(short *)TheGVValue;
  else if (strcmp("cleansing_half_interval", TheGVName) == 0)
    cleansing_half_interval = *(double *)TheGVValue;
  else if (strcmp("common_pfd", TheGVName) == 0)
    common_pfd = *(double *)TheGVValue;
  else if (strcmp("compromise_detection_prob", TheGVName) == 0)
    compromise_detection_prob = *(double *)TheGVValue;
  else if (strcmp("delay_sync_attack", TheGVName) == 0)
    delay_sync_attack = *(double *)TheGVValue;
  else if (strcmp("demand_default_rate", TheGVName) == 0)
    demand_default_rate = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_0", TheGVName) == 0)
    demand_rate_0_0 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_1", TheGVName) == 0)
    demand_rate_0_1 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_2", TheGVName) == 0)
    demand_rate_0_2 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_3", TheGVName) == 0)
    demand_rate_0_3 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_4", TheGVName) == 0)
    demand_rate_0_4 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_0_default", TheGVName) == 0)
    demand_rate_0_default = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_0", TheGVName) == 0)
    demand_rate_1_0 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_1", TheGVName) == 0)
    demand_rate_1_1 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_2", TheGVName) == 0)
    demand_rate_1_2 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_3", TheGVName) == 0)
    demand_rate_1_3 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_4", TheGVName) == 0)
    demand_rate_1_4 = *(double *)TheGVValue;
  else if (strcmp("demand_rate_1_default", TheGVName) == 0)
    demand_rate_1_default = *(double *)TheGVValue;
  else if (strcmp("demand_types_ch1", TheGVName) == 0)
    demand_types_ch1 = *(short *)TheGVValue;
  else if (strcmp("demand_types_ch2", TheGVName) == 0)
    demand_types_ch2 = *(short *)TheGVValue;
  else if (strcmp("demand_types_max", TheGVName) == 0)
    demand_types_max = *(short *)TheGVValue;
  else if (strcmp("evolutionInterval", TheGVName) == 0)
    evolutionInterval = *(double *)TheGVValue;
  else if (strcmp("evolution_enabled", TheGVName) == 0)
    evolution_enabled = *(short *)TheGVValue;
  else if (strcmp("isAttackListTheSame", TheGVName) == 0)
    isAttackListTheSame = *(short *)TheGVValue;
  else if (strcmp("isPatchingDelayed", TheGVName) == 0)
    isPatchingDelayed = *(short *)TheGVValue;
  else if (strcmp("malicious_demand_max_FRs", TheGVName) == 0)
    malicious_demand_max_FRs = *(short *)TheGVValue;
  else if (strcmp("normal_demands_intervals", TheGVName) == 0)
    normal_demands_intervals = *(double *)TheGVValue;
  else if (strcmp("patchingInterval", TheGVName) == 0)
    patchingInterval = *(double *)TheGVValue;
  else if (strcmp("patching_channel_pfd_reduction", TheGVName) == 0)
    patching_channel_pfd_reduction = *(double *)TheGVValue;
  else if (strcmp("patching_common_pfd_reduction", TheGVName) == 0)
    patching_common_pfd_reduction = *(double *)TheGVValue;
  else if (strcmp("patching_enabled", TheGVName) == 0)
    patching_enabled = *(short *)TheGVValue;
  else if (strcmp("patching_model", TheGVName) == 0)
    patching_model = *(int *)TheGVValue;
  else if (strcmp("time_sync_enabled", TheGVName) == 0)
    time_sync_enabled = *(short *)TheGVValue;
  else if (strcmp("upgrade_duration", TheGVName) == 0)
    upgrade_duration = *(double *)TheGVValue;
  else 
    cerr<<"!! study_2SetStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void study_2SetStudy::SetGVs(int expNum) {
  FR_increment = FR_incrementValues[expNum];
  FR_init_pfd = FR_init_pfdValues[expNum];
  FR_other_pfd = FR_other_pfdValues[expNum];
  attackRateIncrement = attackRateIncrementValues[expNum];
  attack_success_prob_reduction = attack_success_prob_reductionValues[expNum];
  ch1_init_pfd = ch1_init_pfdValues[expNum];
  ch2_init_pfd = ch2_init_pfdValues[expNum];
  cleansing_enabled = cleansing_enabledValues[expNum];
  cleansing_half_interval = cleansing_half_intervalValues[expNum];
  common_pfd = common_pfdValues[expNum];
  compromise_detection_prob = compromise_detection_probValues[expNum];
  delay_sync_attack = delay_sync_attackValues[expNum];
  demand_default_rate = demand_default_rateValues[expNum];
  demand_rate_0_0 = demand_rate_0_0Values[expNum];
  demand_rate_0_1 = demand_rate_0_1Values[expNum];
  demand_rate_0_2 = demand_rate_0_2Values[expNum];
  demand_rate_0_3 = demand_rate_0_3Values[expNum];
  demand_rate_0_4 = demand_rate_0_4Values[expNum];
  demand_rate_0_default = demand_rate_0_defaultValues[expNum];
  demand_rate_1_0 = demand_rate_1_0Values[expNum];
  demand_rate_1_1 = demand_rate_1_1Values[expNum];
  demand_rate_1_2 = demand_rate_1_2Values[expNum];
  demand_rate_1_3 = demand_rate_1_3Values[expNum];
  demand_rate_1_4 = demand_rate_1_4Values[expNum];
  demand_rate_1_default = demand_rate_1_defaultValues[expNum];
  demand_types_ch1 = demand_types_ch1Values[expNum];
  demand_types_ch2 = demand_types_ch2Values[expNum];
  demand_types_max = demand_types_maxValues[expNum];
  evolutionInterval = evolutionIntervalValues[expNum];
  evolution_enabled = evolution_enabledValues[expNum];
  isAttackListTheSame = isAttackListTheSameValues[expNum];
  isPatchingDelayed = isPatchingDelayedValues[expNum];
  malicious_demand_max_FRs = malicious_demand_max_FRsValues[expNum];
  normal_demands_intervals = normal_demands_intervalsValues[expNum];
  patchingInterval = patchingIntervalValues[expNum];
  patching_channel_pfd_reduction = patching_channel_pfd_reductionValues[expNum];
  patching_common_pfd_reduction = patching_common_pfd_reductionValues[expNum];
  patching_enabled = patching_enabledValues[expNum];
  patching_model = patching_modelValues[expNum];
  time_sync_enabled = time_sync_enabledValues[expNum];
  upgrade_duration = upgrade_durationValues[expNum];
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new study_2SetStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* study_2SetStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new SW_RewardPVModel(expandTimeArrays);
  return ThePVModel;
}


